#include "phy.h"
#include "elements.h"

const element tabMix[][3] =
{
	/* ELEMENTS SECONDAIRES */
	// combinaisons naturelles d'éléments primaires // +0
	{eau, air, glace},
	{eau, terre, boue},
	{air, feu, flamme},
	{feu, terre, braise}, // useless
	// combinaisons d'éléments primaires opposés // +1
	{air, terre, poussiere},
	{eau, feu, vapeur},
	// combinaisons pures d'éléments primaires // +1
	{terre, terre, roche},
	{air, air, vent},
	// {eau, eau, mer},

	/* ELEMENTS TRANSITIONNELS */ // sous-ensemble des secondaires
	// Transitionnels du premier rang :
	// combinaisons d'éléments primaires et secondaires // +0/+1
	// {feu, vent, foudre},
	{feu, roche, lave}, // +1
	{eau, roche, cristal}, // +0
	{terre, boue, bois}, // +1
	{terre, roche, montagne}, // +0
	{eau, vapeur, brume}, // +0 // ?
	{air, vapeur, nuage}, // +1
	// Transitionnels du second rang
	// combinaisons d'éléments primaires et transitionnels // +0/+1
	{feu, cristal, rubis}, // +0 // achievement
	{eau, cristal, opale}, // +0 // achievement
	{eau, nuage, pluie}, // +2
	{eau, bois, plante}, // +1
	{feu, bois, cendres}, // +0 // achievement
	{eau, plante, algue}, // +0 // achievement

	/* ELEMENTS TERTIAIRES */
	// combinaisons de deux éléments secondaires
	// (ou transitionnels, puisque les transitionnels sont des secondaires)
	{lave, montagne, volcan}, // +0 // achievement
	{flamme, poussiere, sable}, // +0 // achievement
	{vent, nuage, tempete}, // +0 // achievement // FIXME : laisse 1 materia
	{pluie, vent, deluge}, // +0 // achievement
	{pluie, glace, grele}, // +0 // achievement
	{vent, glace, blizard}, // +0 // achievement
	// {nuage, glace, neige},
	// {vent, flamme, foudre},
	// {brume, boue, marecage}, // {marecage, plante, dionee},
	// {brume, ???, marais},
	// {pluie, foudre, orage},

	// combinaisons pures d'éléments secondaires
	{vent, vent, tornade}, // +1
	{roche, roche, metal}, // +1

/*
   	{plante, cristal, emeraude},
	{plante, pluie, mousse},
	{plante, marais, champignon},
	{plante, mer, algue},
	{algue, champignon, lichen},
	{lichen, roche, lichen_gris},
	{lichen, bois, lichen_vert},
	{marais, tenebres, marecages},
	{plante, marecage, drosera},
	{drosera, rubis, dionee},
	{vent, lumiere, foudre},
	{poussiere, tenebres, cendres},
	{mer, vent, embrun},
	{mer, brume, embrun},
	{lumiere, foudre, eclair},
*/
	{-1, -1, -1}
};

element mix (element e1, element e2) {
	int i;
	for (i=0; tabMix[i][0] != -1; i++) {
		if ((e1 == tabMix[i][0] && e2 == tabMix[i][1]) || (e2 == tabMix[i][0] && e1 == tabMix[i][1])) {
			return (tabMix[i][2]);
		}
	}
}

