#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// Utiliser cette librairie pour cherche() ?
// #include <regexp.h>

#include "phy.h"
#include "elements.h"
#include "my_raw.h"

// TODO : Il parait que "pluie" est buggé.

/**********
 * PROMPT *
 **********/

char prompt (char *p) {
	char c;
	printf ("%s ", p);
	read (0, &c, 1);
	return (c);
}

element prompt_element (char *p) {
	// 10 is the length of decimal notation of 2^(4*8)
	// which is the max integer written on 4 bytes
	char buf[10+1];
	int i;
	char c;
	printf ("%s ", p);
	i = 0;
	while (1) {
		read (0, &c, 1);
		if (c == '\n' || i == 11) {
			buf[i] = '\0';
			printf ("\n");
			i = atoi (buf);
			if (est_valide (i))
				return (i);
			else {
				printf ("Élément %d invalide !\n", i);
				printf ("%s ", p);
				i = 0;
				continue;
			}
		}
		if (c == 27) { // ESC
			printf ("\nAnnulé");
			return (0);
		}
		else if (c >= '0' && c <= '9') {
			if (i<10) {
				printf ("%c", c);
				buf[i++] = c;
			}
		}
		else if (c == '\b' || c == '\x7F') {
			if (i>0) {
				write (1, "\b \b", 3);
				i--;
			}
		}
		else if (c == 'e' || c == 'E') {
			printf ("Eau\n");
			return (eau);
		}
		else if (c == 'a' || c == 'A') {
			printf ("Air\n");
			return (air);
		}
		else if (c == 'f' || c == 'F') {
			printf ("Feu\n");
			return (feu);
		}
		else if (c == 't' || c == 'T') {
			printf ("Terre\n");
			return (terre);
		}
	}
}

// TODO : remplacer "Eau", "Air", "Feu" et "Terre" par nom(1), nom(2), nom(3) et nom(4).

element prompt_primaire (char *p) {
	element e;
	char c;
	printf ("%s ", p);
	do {
		read (0, &c, 1);
		if (c >= 'A' && c <= 'Z')
			c -= ('A' - 'a');
	} while (! (c == 27 || c == 'e' || c == 'a' || c == 'f' || c == 't'));
	if (c == 27) { // ESC
		printf ("Annulé");
		return (-1);
	}
	if (c == 'e') {
		printf ("Eau\n");
		return (eau);
	}
	if (c == 'a') {
		printf ("Air\n");
		return (air);
	}
	if (c == 'f') {
		printf ("Feu\n");
		return (feu);
	}
	if (c == 't') {
		printf ("Terre\n");
		return (terre);
	}
}

int prompt_bool (char *p) {
	char c;
	printf ("%s ", p);
	read (0, &c, 1);
	if (c == 'o' || c == 'O' || c == 'y' || c == 'Y' || c == '\n' || c == 'm' || c == 'M') {
		printf ("OK !\n");
		return (1);
	}
	// if (c == 27 || c == 'n' || c == 'N' || c == 'q' || c == 'Q') {
	else {
		printf ("Non.\n");
		return (0);
	}
}

/*******
 * S-P *
 *******/

void list (int * qtt) {
	int i;
	printf ("ID\tValeur\tQtt\tNom\n");
	for (i=0; i<NB_ELEMENTS; i++) {
		if (qtt[i] != 0) {
			printf ("%d\t%d\t%d\t%s\n", i, valeur(i), qtt[i], nom(i));
		}
	}
}

#ifdef COMMANDE_S
int cherche () {
	int i;
	char c;
	c = prompt ("Entrez une initiale :");
	if (c >= 'a' && c <= 'z') {
		c += ('A' - 'a');
	}
	else if (! (c >= 'A' && c <= 'Z')) {
		return (-1);
	}
	printf ("%c\n", c);
	for (i=0; i<NB_ELEMENTS; i++) {
		if (nom(i)[0] == c) {
			printf ("%03d : %s\n", i, nom (i));
		}
	}
	return (0);
}
#endif

void recommencer (int qtt[]) {
	int i;
	qtt[0] = INIT_MATERIA;
	for (i=1; i<NB_ELEMENTS; i++) {
		qtt[i] = 0;
	}
}

int score (int qtt[]) {
	int i;
	int score = 0;
	for (i=0; i<NB_ELEMENTS; i++) {
		if (qtt[i] != 0) {
			score += valeur (i) * qtt[i];
		}
	}
	return (score-3);
}

/*******
 * ASK *
 *******/

int ask_polarise (int qtt[]) {
	element enquoi;
	int combien;
	if (qtt[0] == 0) {
		printf ("Vous n'avez pas de %s à polariser.\n", nom (0));
		return (-1);
	}
	printf ("Vous avez %d %s à polariser.\n", qtt[0], nom (0));
/*
	printf ("Combien de %s voulez-vous polariser ?\n", nom(0));
	combien = prompt_int ("Entrez -1 pour annuler, ou 0 (ou <ENTER>) pour tout polariser:");
	if (combien < 0) {
		return (-1);
	}
	else if (combien == 0) {
		combien = qtt[0];
	}
	else if (combien > qtt[0]) {
		printf ("Vous n'avez pas autant de %s !\n", nom(0));
		return (-1);
	}
*/
	combien = 1;

	printf ("En quel élément voulez-vous polariser votre %s ?\n", nom (0));
	printf ("E pour %s, A pour %s, F pour %s et T pour %s.\n", nom(1), nom(2), nom(3), nom(4));
	enquoi = prompt_primaire ("*");
/*
	enquoi = prompt_element (":");
	if (! est_primaire (enquoi)) {
		printf ("%d n'est pas un élément primaire !\n", enquoi);
		return (-1);
	}
*/
	if (enquoi == -1)
		return (-1);
	qtt[0] -= combien;
	qtt[enquoi] += combien;
}

int ask_melange (int qtt[]) {
	element premier, second, melange;
	int gain;
	int i, total;

	for (i=1, total=0; i<NB_ELEMENTS; i++) {
		// if (qtt[i] != 0)
			total += qtt[i];
	}

	if (total < 2) { // pas assez
		printf ("Vous n'avez pas assez d'éléments pour tenter un mélange.\n");
		return (-1);
	}
	if (total == 2) { // juste deux
		for (i=1; qtt[i] < 1; i++) { }
		premier = i;
		if (qtt[i] == 1)
			for (i++; qtt[i] < 1; i++) { }
		second = i;

		printf ("Mélange de %s et %s. OK ?\n", nom (premier), nom (second));
		if (! prompt_bool ("?"))
			return (-1);
	}
	else { // plus de deux

		// traitement du premier élément
		premier = prompt_element ("Premier élément:");
		if (premier == 0) {
			// printf ("Vous ne pouvez utiliser de la %s de cette façon.\n", nom (0));
			return (-1);
		}
		if (qtt[premier] < 1) {
			// printf ("Vous n'avez pas de %s !\n", nom (premier));
			printf ("Vous n'avez pas de cet élément !\n");
			return (-1);
		}
	
		// traitement du second élément
		second = prompt_element ("Second élément:");
		if (second == 0) {
			// printf ("Vous ne pouvez utiliser de la %s de cette façon.\n", nom (0));
			return (-1);
		}
		if (qtt[second] < 1) {
			// printf ("Vous n'avez pas de %s !\n", nom (second));
			printf ("Vous n'avez pas de cet élément !\n");
			return (-1);
		}

		// vérification de quantité
		if (premier == second && qtt[premier] == 1) {
			printf ("Vous n'avez qu'un seul %s !\n", nom (premier));
			return (-1);
		}
	}

	// en arrivant à ce point, soit premier et second sont définits,
	// soit la fonction a déjà retourné (-1).

	// mélange
	melange = mix (premier, second);
	if (melange == NON_ELEMENT) {
		printf ("Ce mélange ne donne rien...\n");
#ifdef HARDCORE
		qtt[premier]--;
		qtt[second]--;
#endif
	}
	else {
		printf ("Ce mélange donne l'élément %d : %s.\n", melange, nom (melange));
		gain = valeur (melange) - (valeur (premier) + valeur (second));
		if (gain > 0) {
			printf ("Vous créez %d %s !\n", gain, nom (0));
			qtt[0] += gain;
		}
		qtt[melange]++;
		qtt[premier]--;
		qtt[second]--;
	}
}

/********
 * MAIN *
 ********/

void help ();
void version ();

int main () {
	int i;
	element e;
	char c;
	int qtt[NB_ELEMENTS];

	// init
	qtt[0] = INIT_MATERIA;
	for (i=1; i<NB_ELEMENTS; i++) {
		qtt[i] = 0;
	}

#ifndef NO_RAW
	set_raw (1);
#endif

	printf("Bienvenue sur Phy ! Appuyez sur A pour obtenir de l'Aide.\n");

	// loop
	for (c = prompt(">"); c != 'q' && c != 'Q' ; c = prompt(">")) {
		if (c >= 'A' && c <= 'Z') {
			c -= 'A' - 'a';
		}
		if (c == 'a') {
			printf ("Aide\n");
			help ();
		}
		else if (c == 'v') {
			printf ("Version\n");
			version ();
		}
		else if (c == 'p') {
			printf ("Polarise\n");
			if (ask_polarise (qtt) == -1)
				printf ("\n");
		}
		else if (c == 'm') {
			printf ("Mélange\n");
			if (ask_melange (qtt) == -1)
				printf ("\n");
		}
		else if (c == 'l') {
			printf ("List\n");
			list (qtt);
		}
		else if (c == 's') {
			printf ("Score\n");
			printf (": %d.\n", score (qtt));
		}
		else if (c == 'r') {
			printf ("Recommencer\n");
			recommencer (qtt);
		}
		else if (c == '\n') {
			printf ("\r");
			continue;
		}
#ifdef COMMANDE_ELEMENT
		else if (c == 'e') {
			printf ("Element\n");
			e = prompt_element ("id:");
			if (qtt[e] > 0) {
				printf ("#%d : %s (Qtt: %d ; Valeur: %d)\n", e, nom (e), qtt[e], valeur (e));
			}
			else {
				printf ("Vous ne possédez pas cet élément !\n");
			}
		}
#endif
#ifdef COMMANDE_CHERCHE
		else if (c == 'c') {
			printf ("Cherche\n");
			if (cherche () == -1)
				printf ("\n");
		}
#endif
		else {
			// printf ("%c\n", c);
			printf ("\rCommande non reconnue. Entrez 'a' pour obtenir la liste des commandes.\n");
		}
	}
	printf ("Quit\n");

#ifndef NO_RAW
	set_raw (0);
#endif
}

void help () {
	printf ("Liste des commandes.\n");
	printf ("p : polarise de la materia.\n");
	printf ("m : melange deux elements.\n");
	printf ("l : liste les elements possédés.\n");
#ifdef COMMANDE_ELEMENT
	printf ("e : affiche les caracteristiques d'un élément.\n");
#endif
#ifdef COMMANDE_CHERCHE
	printf ("c : cherche l'id d'un element en fonction du nom.\n");
#endif
	printf ("s : compter les points.\n");
	printf ("r : recommencer.\n");
	printf ("a : affiche cette aide.\n");
	printf ("v : affiche la version et les options de compilation.\n");
	printf ("q : quitter.\n");
}

void version () {
	printf ("%s\n", PROGNAME);
	printf ("Author: %s.\n", AUTHOR);
	printf ("Version: %d.\n", VERSION);
	printf ("Init %s: %d.\n", nom(0), INIT_MATERIA);
#ifdef HARDCORE
	printf ("Mode : Hardcore.\n");
#endif
#ifdef NO_RAW
	printf ("Input : no raw.\n");
#else
	printf ("Input : raw.\n");
#endif
#ifdef COMMANDE_ELEMENT
	printf ("Whith: COMMANDE_ELEMENT.\n");
#endif
#ifdef COMMANDE_CHERCHE
	printf ("With : COMMANDE_CHERCHE.\n");
#endif
}
